//
//  CGOLEditView.swift
//  ConwaysGameOfLife
//
//  Created by narita on 2018/08/31.
//  Copyright © 2018年 narita. All rights reserved.
//

import Cocoa

class CGOLEditView: CGOLView
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    // MARK: - event handling methods
    
    override func mouseDown(with event: NSEvent)
    {
        // 座標変換して
        let theWindowPoint = event.locationInWindow
        let theViewPoint   = self.convert(theWindowPoint, from: nil)
        let theModelPoint  = self.modelPointFrom(viewPoint: theViewPoint)
        
        // 鉛筆ツール風に反転させる
        let theBool = self.model?.alive(at: theModelPoint)
        self.model?.setAlive( theBool == .alive ? .died : .alive, at: theModelPoint)
    }
    
    override func mouseDragged(with event: NSEvent)
    {
        // 今回は不使用
    }
    
    override func mouseUp(with event: NSEvent)
    {
        // 今回は不使用
    }
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    // MARK: - Utility methods
    private func modelPointFrom(viewPoint: NSPoint) -> CGOLPoint
    {
        // 10 * 10 ptを1cellとする
        let x = NSInteger(viewPoint.x) / 10
        let y = NSInteger(viewPoint.y) / 10
        
        
        return CGOLPoint(x: x, y: y)
    }

}
